// RockTexture.cpp
/* RockTexture.cpp defines the nontrivial members of class RockTexture.
 **********************************************************************/

#include <string>
#include <ctype.h>

#include "RockTexture.h"

// -------- Read a value into me from in ----------------------------
void RockTexture::Read(istream & in)
{
   string rockKindString;
   in >> rockKindString;

   for (int i = 0; i < rockKindString.size(); i++)
      if (islower(rockKindString[i]))
         rockKindString[i] = toupper(rockKindString[i]);

   if (rockKindString== "COARSE")
      myRockTextureName = COARSE;
   else if (rockKindString== "INTERMEDIATE")
      myRockTextureName = INTERMEDIATE;
   else if (rockKindString== "FINE")
      myRockTextureName = FINE;
   else
   {
      cerr << "\n*** Read: Rock texture is unknown\n" 
           << endl;
      in.setstate(ios::failbit);
   }
}

// -------- Display me via out --------------------------
void RockTexture::Print(ostream & out) const
{
   switch(myRockTextureName)
   {
      case COARSE:       out << "COARSE";     
                         break;
      case INTERMEDIATE: out << "INTERMEDIATE"; 
                         break;
      case FINE:         out << "FINE"; 
                         break;
   }
}

// -------- Increment me (prefix) --------------------------
RockTexture RockTexture::operator++()
{
   switch(myRockTextureName)
   {
      case COARSE:       myRockTextureName = INTERMEDIATE;  
                         break;
      case INTERMEDIATE: myRockTextureName = FINE;
                         break;
      case FINE:         myRockTextureName = TEXTURE_OVERFLOW;
                         break;
   }
   return RockTexture(myRockTextureName);
}

// -------- Increment me (postfix) --------------------------
RockTexture RockTexture::operator++(int)
{
   RockTextureName savedRockTextureName = myRockTextureName;
   switch(myRockTextureName)
   {
      case COARSE:       myRockTextureName = INTERMEDIATE;  
                         break;
      case INTERMEDIATE: myRockTextureName = FINE;
                         break;
      case FINE:         myRockTextureName = TEXTURE_OVERFLOW;
                         break;
    }
   return RockTexture(savedRockTextureName);
}

// -------- Decrement me (prefix) -------------------------------------
// -------- Decrement me (postfix) ------------------------------------

// Definitions of operator--() and operator--(int) are similar to those
// of operator++() and perator++(int) and are omitted to save space.
